pcl::RandomizedRandomSampleConsensus< PointT > Class Template Reference
Module sample_consensus

RandomizedRandomSampleConsensus represents an implementation of the RRANSAC (Randomized RAndom SAmple Consensus), as described in "Randomized RANSAC with Td,d test", O. More...

`#include <pcl/sample_consensus/rransac.h>`

Inheritance diagram for pcl::RandomizedRandomSampleConsensus< PointT >:

## Public Types

typedef boost::shared_ptr< RandomizedRandomSampleConsensus > | Ptr
typedef boost::shared_ptr< const RandomizedRandomSampleConsensus > | ConstPtr
Public Types inherited from pcl::SampleConsensus< PointT >
typedef boost::shared_ptr< SampleConsensus > | Ptr
typedef boost::shared_ptr< const SampleConsensus > | ConstPtr

## Public Member Functions

| RandomizedRandomSampleConsensus (const SampleConsensusModelPtr &model)
| RANSAC (Randomized RAndom SAmple Consensus) main constructor. More...
| RandomizedRandomSampleConsensus (const SampleConsensusModelPtr &model, double threshold)
| RRANSAC (RAndom SAmple Consensus) main constructor. More...
bool | computeModel (int debug_verbosity_level=0)
| Compute the actual model and find the inliers. More...
void | setFractionNrPretest (double nr_pretest)
| Set the percentage of points to pre-test. More...
double | getFractionNrPretest ()
| Get the percentage of points to pre-test. More...
Public Member Functions inherited from pcl::SampleConsensus< PointT >
| SampleConsensus (const SampleConsensusModelPtr &model, bool random=false)
| Constructor for base SAC. More...
| SampleConsensus (const SampleConsensusModelPtr &model, double threshold, bool random=false)
| Constructor for base SAC. More...
void | setSampleConsensusModel (const SampleConsensusModelPtr &model)
| Set the Sample Consensus model to use. More...
SampleConsensusModelPtr | getSampleConsensusModel () const
| Get the Sample Consensus model used. More...
virtual | ~SampleConsensus ()
| Destructor for base SAC. More...
void | setDistanceThreshold (double threshold)
| Set the distance to model threshold. More...
double | getDistanceThreshold ()
| Get the distance to model threshold, as set by the user. More...
void | setMaxIterations (int max_iterations)
| Set the maximum number of iterations. More...
int | getMaxIterations ()
| Get the maximum number of iterations, as set by the user. More...
void | setProbability (double probability)
| Set the desired probability of choosing at least one sample free from outliers. More...
double | getProbability ()
| Obtain the probability of choosing at least one sample free from outliers, as set by the user. More...
virtual bool | refineModel (const double sigma=3.0, const unsigned int max_iterations=1000)
| Refine the model found. More...
void | getRandomSamples (const boost::shared_ptr< std::vector< int > > &indices, size_t nr_samples, std::set< int > &indices_subset)
| Get a set of randomly selected indices. More...
void | getModel (std::vector< int > &model)
| Return the best model found so far. More...
void | getInliers (std::vector< int > &inliers)
| Return the best set of inliers found so far for this model. More...
void | getModelCoefficients (Eigen::VectorXf &model_coefficients)
| Return the model coefficients of the best model found so far. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::SampleConsensus< PointT >
double | rnd ()
| Boost-based random number generator. More...
Protected Attributes inherited from pcl::SampleConsensus< PointT >
SampleConsensusModelPtr | sac_model_
| The underlying data model used (i.e. More...
std::vector< int > | model_
| The model found after the last computeModel () as point cloud indices. More...
std::vector< int > | inliers_
| The indices of the points that were chosen as inliers after the last computeModel () call. More...
Eigen::VectorXf | model_coefficients_
| The coefficients of our model computed directly from the model found. More...
double | probability_
| Desired probability of choosing at least one sample free from outliers. More...
int | iterations_
| Total number of internal loop iterations that we've done so far. More...
double | threshold_
| Distance to model threshold. More...
int | max_iterations_
| Maximum number of iterations before giving up. More...
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm. More...
boost::shared_ptr< boost::uniform_01< boost::mt19937 > > | rng_
| Boost-based random number generator distribution. More...

## Detailed Description

### template<typename PointT>
class pcl::RandomizedRandomSampleConsensus< PointT >

RandomizedRandomSampleConsensus represents an implementation of the RRANSAC (Randomized RAndom SAmple Consensus), as described in "Randomized RANSAC with Td,d test", O.

Chum and J. Matas, Proc. British Machine Vision Conf. (BMVC '02), vol. 2, BMVA, pp. 448-457, 2002.

Note
  RRANSAC is useful in situations where most of the data samples belong to the model, and a fast outlier rejection algorithm is needed.

Author
  Radu B. Rusu

Definition at line 57 of file rransac.h.

## Member Typedef Documentation

template<typename PointT >

typedef boost::shared_ptr<const RandomizedRandomSampleConsensus> pcl::RandomizedRandomSampleConsensus< PointT >::ConstPtr

Definition at line 63 of file rransac.h.

template<typename PointT >

typedef boost::shared_ptr<RandomizedRandomSampleConsensus> pcl::RandomizedRandomSampleConsensus< PointT >::Ptr

Definition at line 62 of file rransac.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::RandomizedRandomSampleConsensus< PointT >::RandomizedRandomSampleConsensus | ( | const SampleConsensusModelPtr & | model | ) |

inline

RANSAC (Randomized RAndom SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model

Definition at line 77 of file rransac.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

template<typename PointT >

pcl::RandomizedRandomSampleConsensus< PointT >::RandomizedRandomSampleConsensus | ( | const SampleConsensusModelPtr & | model,
|  | double | threshold
| ) |  |

inline

RRANSAC (RAndom SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model
  [in] | threshold | distance to model threshold

Definition at line 89 of file rransac.h.

References pcl::RandomizedRandomSampleConsensus< PointT >::computeModel(), and pcl::SampleConsensus< PointT >::max_iterations_.

## Member Function Documentation

template<typename PointT >

bool pcl::RandomizedRandomSampleConsensus< PointT >::computeModel | ( | int | debug_verbosity_level = `0` | ) |

virtual

Compute the actual model and find the inliers.

Parameters

  [in] | debug_verbosity_level | enable/disable on-screen debug information and set the verbosity level

Implements pcl::SampleConsensus< PointT >.

Definition at line 48 of file rransac.hpp.

Referenced by pcl::RandomizedRandomSampleConsensus< PointT >::RandomizedRandomSampleConsensus().

template<typename PointT >

double pcl::RandomizedRandomSampleConsensus< PointT >::getFractionNrPretest | ( |  | ) |

inline

Get the percentage of points to pre-test.

Definition at line 111 of file rransac.h.

template<typename PointT >

void pcl::RandomizedRandomSampleConsensus< PointT >::setFractionNrPretest | ( | double | nr_pretest | ) |

inline

Set the percentage of points to pre-test.

Parameters

  [in] | nr_pretest | percentage of points to pre-test

Definition at line 107 of file rransac.h.

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/sample_consensus/include/pcl/sample_consensus/rransac.h
- /build/pcl-0nnAvv/pcl-1.7.2/sample_consensus/include/pcl/sample_consensus/impl/rransac.hpp